
; PICBASIC PRO(TM) Compiler Demo, (c) 1998, 2009 microEngineering Labs, Inc. All Rights Reserved. 
PM_USED			EQU	1

	INCLUDE	"16F886.INC"


; Define statements.
#define		CODE_SIZE		 8


RAM_START       		EQU	00020h
RAM_END         		EQU	001EFh
RAM_BANKS       		EQU	00004h
BANK0_START     		EQU	00020h
BANK0_END       		EQU	0007Fh
BANK1_START     		EQU	000A0h
BANK1_END       		EQU	000EFh
BANK2_START     		EQU	00110h
BANK2_END       		EQU	0016Fh
BANK3_START     		EQU	00190h
BANK3_END       		EQU	001EFh
EEPROM_START    		EQU	02100h
EEPROM_END      		EQU	021FFh

R0              		EQU	RAM_START + 000h
R1              		EQU	RAM_START + 002h
R2              		EQU	RAM_START + 004h
R3              		EQU	RAM_START + 006h
R4              		EQU	RAM_START + 008h
R5              		EQU	RAM_START + 00Ah
R6              		EQU	RAM_START + 00Ch
R7              		EQU	RAM_START + 00Eh
R8              		EQU	RAM_START + 010h
FLAGS           		EQU	RAM_START + 012h
GOP             		EQU	RAM_START + 013h
RM1             		EQU	RAM_START + 014h
RM2             		EQU	RAM_START + 015h
RR1             		EQU	RAM_START + 016h
RR2             		EQU	RAM_START + 017h
_Steps           		EQU	RAM_START + 018h
_J               		EQU	RAM_START + 01Ch
_Pulses          		EQU	RAM_START + 01Eh
_Revolutions     		EQU	RAM_START + 020h
T1              		EQU	RAM_START + 022h
_I               		EQU	RAM_START + 024h
_PORTL           		EQU	 PORTB
_PORTH           		EQU	 PORTC
_TRISL           		EQU	 TRISB
_TRISH           		EQU	 TRISC
	INCLUDE	"STEPMO~1.MAC"
	INCLUDE	"PBPPIC14.LIB"

	MOVE?CB	0C0h, ADCON0
	MOVE?CB	000h, WPUB
	MOVE?CB	000h, ANSELH
	MOVE?CB	000h, TRISB
	MOVE?CW	001h, _Revolutions
	MUL?CWW	030h, _Revolutions, _Pulses
	DIV?WCW	_Pulses, 004h, _Pulses

	LABEL?L	_run	
	MOVE?CB	001h, _Steps
	MOVE?CB	002h, _Steps + 00001h
	MOVE?CB	004h, _Steps + 00002h
	MOVE?CB	008h, _Steps + 00003h
	MOVE?CW	001h, _J
	LABEL?L	L00001	
	CMPGT?WWL	_J, _Pulses, L00002
	MOVE?CB	000h, _I
	LABEL?L	L00003	
	CMPGT?BCL	_I, 003h, L00004
	AOUT?BBB	_Steps, _I, PORTB
	PAUSE?C	01Eh
	NEXT?BCL	_I, 001h, L00003
	LABEL?L	L00004	
	NEXT?WCL	_J, 001h, L00001
	LABEL?L	L00002	
	MOVE?CB	008h, _Steps
	MOVE?CB	004h, _Steps + 00001h
	MOVE?CB	002h, _Steps + 00002h
	MOVE?CB	001h, _Steps + 00003h
	MOVE?CW	001h, _J
	LABEL?L	L00005	
	CMPGT?WWL	_J, _Pulses, L00006
	MOVE?CB	000h, _I
	LABEL?L	L00007	
	CMPGT?BCL	_I, 003h, L00008
	AOUT?BBB	_Steps, _I, PORTB
	PAUSE?C	01Eh
	NEXT?BCL	_I, 001h, L00007
	LABEL?L	L00008	
	NEXT?WCL	_J, 001h, L00005
	LABEL?L	L00006	
	MOVE?CB	0FFh, PORTB
	PAUSE?C	00BB8h
	GOTO?L	_run
	END?	

	END
